# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.http.response import Http404
from newsbox.views import NewsboxDetailView
from django.utils.translation import get_language


class NewsboxI18NPublishedMixinView(object):

    def get_queryset(self):
        queryset = super(NewsboxI18NPublishedMixinView, self).get_queryset()
        queryset = queryset.active_translations()
        return queryset


class NewsboxI18NDetailView(NewsboxI18NPublishedMixinView, NewsboxDetailView):

    slug_field = "translations__newsbox_slug"

    def get_object(self, queryset=None):
        """
        As slug_field is translated, we need to use translation aware
        queryset.
        """
        if not queryset:
            queryset = self.get_queryset()
        language = get_language()
        queryset = queryset.translated(language, newsbox_slug=self.kwargs[self.slug_url_kwarg])
        return super(NewsboxI18NDetailView, self).get_object(queryset)
